#include "lenguaje.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <io.h>

extern char DIRINFO[256]; //Usada para alojar el nombre del archivo donde se encuentra la informacion de los directorios. En ICD.CPP
extern char DIR_ACTUAL[256]; //En ICD.C
extern FILE *DIRINFO_ARCHIVO; //En ICD.C
extern unsigned NUMDIR; //En ICD.C, aca se usa para hacer el programa mas compacto, es para contar por que paso de la busqueda va.

char *BUFFER; //El puntero hacia los datos del archivo DIRINFO.
unsigned TAMANO; //Muchas funciones usan esto que indica el tamano del BUFFER.

unsigned ERRORES=0; //Usado por el metodo INEXACTO

//Retorna -1 si se llego al final del archivo, deja a puntero justo al inicio del siguiente DIR.
//Pasarle por referencia al puntero porque lo modifica!
signed SIGUIENTE_DIR(unsigned *PUNTERO)
{
 while(BUFFER[*PUNTERO]!='\n') {
   if(*PUNTERO>=TAMANO) return -1;
   *PUNTERO=*PUNTERO+1;
   }
 *PUNTERO=*PUNTERO+1;
 return 0;
 }

//Compara toda una ruta, 1 si es igual, 0 si es diferente.
signed COMPARA_DIR_COMPLETO(char DIRBUF[], char DIR[])
{
 unsigned DIRPUNTERO=0;
 for(;;) {
   if( (DIR[DIRPUNTERO]==0) && (DIRBUF[DIRPUNTERO]=='\n') ) return 1; //Se llego al final de buffer y dir, entonces hubo coincidencias
   if(DIR[DIRPUNTERO]!=DIRBUF[DIRPUNTERO]) return 0;
   DIRPUNTERO++;
   }
 return 0;
 }

//Retorna 0 si no ubo coincidencia, 1 si ubo. Compara solo la ultima parte, osea el nombre del directorio en si, no la ruta.
signed COMPARA_DIR(unsigned PUNTERO,char DIR[])
{
 char *NOMBRE;
 unsigned ERRORESACT=0;

 while( (PUNTERO<=TAMANO) && (BUFFER[PUNTERO]!='\n') ) PUNTERO++; //Va hasta el final del directorio
 while( BUFFER[PUNTERO]!='\\' ) PUNTERO--; //Busca el ultimo directorio de la ruta completa.
 PUNTERO++; //Lo posiciona justo despues de la barra.
 NOMBRE=&BUFFER[PUNTERO];
 PUNTERO=0;

 if(NUMDIR==2) goto METODO_INEXACTO;

 for( ;; ) {
   if (DIR[PUNTERO]==0) { //Ok, se llego al final de DIR porque coincidio con todas las letras hasta ahora.
     if( (NUMDIR==0) && (NOMBRE[PUNTERO]!='\n') ) return 0; //Si esta activado el paso 0, que es el de buscar la misma cantidad de letras, y NOMBRE tiene mas letras, entonces no coincide.
     return 1; //Si se llego al final de DIR y ubo coincidencias hasta ahora, entonces se encontro el directorio!
     }
   if(NOMBRE[PUNTERO]=='\n') return 0; //Llego al final antes que DIR, entonces no es igual.
   if(NOMBRE[PUNTERO]!=DIR[PUNTERO]) return 0;
   PUNTERO++;
   }

 METODO_INEXACTO:;
 while( DIR[PUNTERO]!=0 && NOMBRE[PUNTERO]!='\n' && ERRORES>=ERRORESACT ) {
   if(DIR[PUNTERO]!=NOMBRE[PUNTERO]) ERRORESACT++;
   PUNTERO++;
   }

 if(DIR[PUNTERO]!=0 && NOMBRE[PUNTERO]=='\n') { //Se encontro un nombre mas pequeno, entonces se verifican a ver por cuantas letras excede el nombre buscado que es DIR.
   while(DIR[PUNTERO]!=0) {
     PUNTERO++;
     ERRORESACT++; //Y los excedientes se cuentan como errores.
     }
   }

 if(ERRORES>=ERRORESACT) return 1; //Bueno, se encontro un nombre con la misma cantidad de errores requeridos, entonces se toma como verdadero.

 if(NOMBRE[0]!='\n') {
   NOMBRE++;
   PUNTERO=0;
   ERRORESACT=0;
   goto METODO_INEXACTO;
   }

 return 0;
 }

void BUSCAR_DIRF(char DIR[])
{
 unsigned ENCONTRADO_IGUAL; //Esto indica que no se encontro el mismo directorio, si se encontro el mismo al DIRACTUAL, entonces esta variable es 1 y si se encuentra el mismo de vuelta quiere decir que no hay mas parecidos a ese, entonces se usa NUMDIR 1 para buscar otro parecido, pero si numdir era 1 entonces termina la busqueda y deja en ese directorio.
 unsigned PUNTERO=0;

 strupr(DIR);
 NUMDIR=0; //Empieza por el paso 0, que es encontrar el nombre completo sin sobras, osea que si le das "DJGPP", busca solo "DJGPP" y no "DJGPPUTI".
 while(DIR_ACTUAL[PUNTERO+2]!=0) { //Esto pasa DIR_ACTUAL pero sin C: para usar en las siguientes rutinas
   DIR_ACTUAL[PUNTERO]=DIR_ACTUAL[PUNTERO+2];
   if(DIR_ACTUAL[PUNTERO]=='/') DIR_ACTUAL[PUNTERO]='\\'; //Estamos en DOS, no en Unix.
   PUNTERO++;
   }
 DIR_ACTUAL[PUNTERO]=0;
 strupr(DIR_ACTUAL);

 EMPIEZA_BUSQUEDA:;
 PUNTERO=0;
 while(PUNTERO<=TAMANO) {
   if( COMPARA_DIR_COMPLETO(&BUFFER[PUNTERO],DIR_ACTUAL)==1 ) {
     ENCONTRADO_IGUAL=1; //Sigue con el siguiente paso que es encontrar otro directorio similar despues del actual. Osea que previene de que se caiga en un BUCLE sin fin si es que el directorio actual no se encuentra.
     if(SIGUIENTE_DIR(&PUNTERO)==-1) PUNTERO=0;
     goto CICLO_BUSQUEDA;
     }
   if( SIGUIENTE_DIR(&PUNTERO)==-1 ) { //Bueno, no se encontro el DIRACT, entonces empieza desde el principio para buscar otro directorio.
     PUNTERO=0;
     //aca hay que hacer cosas para cuando halla que agregar el directorio actual a la lista de directorios.
     goto CICLO_BUSQUEDA;
     }
   }
 PUNTERO=0;

 CICLO_BUSQUEDA:;
 while(PUNTERO<=TAMANO) {
   if( COMPARA_DIR(PUNTERO,DIR)==1 ) goto ENCONTRADO;
   if( SIGUIENTE_DIR(&PUNTERO)==-1 ) goto NOENCONTRADO;
   }
 goto NOENCONTRADO;

 ENCONTRADO:;
 while( (BUFFER[PUNTERO]!='\n') && (PUNTERO!=0) ) PUNTERO--; //Posiciona al inicio del directorio
 if(PUNTERO!=0) PUNTERO++; //No lo deja en el newline

 ENCONTRADO_IGUAL=0;
 while( (PUNTERO<=TAMANO) && (BUFFER[PUNTERO]!='\n') ) {
   DIR_ACTUAL[ENCONTRADO_IGUAL]=BUFFER[PUNTERO];
   ENCONTRADO_IGUAL++; PUNTERO++;
   }
 DIR_ACTUAL[ENCONTRADO_IGUAL]=0;
 #ifdef L_ESPANOL
 printf("\nCambiando al directorio: \"%s\"...\n",DIR_ACTUAL);
 if(chdir(DIR_ACTUAL)) printf("\nEl directorio no existe, rastree de nuevo esta unidad!");
 #endif
 #ifdef L_INGLES
 printf("\nChanging to directory: \"%s\"...\n",DIR_ACTUAL);
 if(chdir(DIR_ACTUAL)) printf("\nThe directory does not exist, rescan this drive!");
 #endif
 return;

 NOENCONTRADO:;
 if(ENCONTRADO_IGUAL==1) { //Se habia encontrado uno igual, entonces se inicia la busqueda desde el principio, porque desde ese directorio igual hasta el final no hubo otra coincidencia!
   PUNTERO=0;
   ENCONTRADO_IGUAL++; //Para seguir con el siguiente paso que es que empiece desde el principio, pero si se encuentra el mismo entonces no hay otra coincidencia y no cambia el directorio.
   goto CICLO_BUSQUEDA;
   }
 if(NUMDIR==0) { //Bueno, si no encontro con igual numero de letras, entonces sigue buscando uno que igual tenga mas letras pero coincidan las primeras letras.
   NUMDIR++; //Indica que ahora tiene que seguir por el segundo paso que es buscar con igual o mayor numero de letras
   PUNTERO=0; //Empieza desde el principio.
   goto EMPIEZA_BUSQUEDA;
   }
 if(NUMDIR==1) { //Bueno, tampoco se encontro un directorio que exceda las letras del directorio pedido pero que coincidan, entonces se usa el metodo inexacto.
   NUMDIR++;
   PUNTERO=0;
   goto EMPIEZA_BUSQUEDA;
   }
 if(NUMDIR==2) { //Estamos en el metodo inexacto, por lo tanto si no se encontro con la exigencia requerida, aumentamos la cantidad de errores que se pueden permitir.
   ERRORES++;
   PUNTERO=0;
   goto EMPIEZA_BUSQUEDA;
   }
 }

void BUSCAR_DIR(char BUSCARDIR[])
{
 if(!chdir(BUSCARDIR)) { //Si el directorio que se mando a buscar existe tal cual, entonces para que buscar?
   #ifdef L_ESPANOL
   printf("Cambiado al directorio: \"%s\".\n",BUSCARDIR);
   #endif
   #ifdef L_INGLES
   printf("Changed to directory: \"%s\".\n",BUSCARDIR);
   #endif
   return;
   }
 #ifdef L_ESPANOL
 printf("Buscando directorio \"%s\" o parecido...", BUSCARDIR); fflush(stdout);
 #endif
 #ifdef L_INGLES
 printf("Searching directory \"%s\" or similar...", BUSCARDIR); fflush(stdout);
 #endif
 DIRINFO_ARCHIVO=fopen(DIRINFO,"rb");
 if(DIRINFO_ARCHIVO==NULL) {
   #ifdef L_ESPANOL
   printf("\nError abriendo el fichero \"%s\", rastree la unidad de vuelta!\n",DIRINFO);
   #endif
   #ifdef L_INGLES
   printf("\nError opening the file \"%s\", rescan this drive!\n",DIRINFO);
   #endif
   return;
   }
 TAMANO=filelength(fileno(DIRINFO_ARCHIVO));
 BUFFER=(char *)malloc(TAMANO);
 fread(BUFFER,1,TAMANO,DIRINFO_ARCHIVO);
 fclose(DIRINFO_ARCHIVO);
 BUSCAR_DIRF(BUSCARDIR);
 free(BUFFER);
 }
