#include "lenguaje.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

extern RASTREAR_DIR(); //en archivo RASTREAR.CPP
extern BUSCAR_DIR(char BUSCARDIR[]); //en archivo BUSCAR.CPP

#ifdef L_ESPANOL
char ENCABEZADO[]="\n       Icd V1.2b [04/01/98] - Creado por Ivan Baldo, Montevideo, Uruguay.       \n";
#endif
#ifdef L_INGLES
char ENCABEZADO[]="\n       Icd V1.2b [01/04/98] - Created by Ivan Baldo, Montevideo, Uruguay.       \n";
#endif

void AYUDA()
{
 #ifdef L_ESPANOL
 printf("Sintaxis de Icd:\n\n");
 printf("         Icd </r>  - Rastrea la unidad actual para actualizar los datos del\n");
 printf("                     arbol de directorios.\n\n");
 printf("         Icd <Dir> - Busca a ese directorio o similar, si se vuelve a llamar con");
 printf("                     el mismo directorio y existe mas de una similitud, entonces");
 printf("                     se cambiar al siguiente directorio similar.\n\n\n");
 printf("Para mas informacin ver el archivo Icd.txt. Para obtener la ltima versin de\n");
 printf("ste programa, mi direccin en internet es: http://xoom.com/baldo.\n\n");
 #endif
 #ifdef L_INGLES
 printf("Syntax of Icd:\n\n");
 printf("         Icd </r>  - Rescan the actual drive to refresh the directory tree data.");
 printf("         Icd <Dir> - Search for that directory or similar, if Icd is called\n");
 printf("                     again with the same directory and exist more than one\n");
 printf("                     similar directory, Icd will change to the next similar\n");
 printf("                     directory.\n\n\n");
 printf("For more information look at the file Icd.txt. To obtain the latest version of\n");
 printf("this program, my internet address is: http://xoom.com/baldo.\n\n");
 #endif
 }

char DIRINFO[256]; //Usada para alojar el nombre del archivo donde se encuentra la informacion de los directorios.
FILE *DIRINFO_ARCHIVO;
char DIR_ACTUAL[256];

// Esta funcion pone en la variable dada, el nombre del archivo donde seran leidos o guardados los datos de los directorios.
void TOMAR_NOMBRE_ARCHIVO()
{
 char *TMP;
 TMP=getenv("ICD"); if(TMP!=NULL) goto LISTO;
 TMP=getenv("TEMP"); if(TMP!=NULL) goto LISTO;
 TMP=getenv("TMP"); if(TMP!=NULL) goto LISTO;
 DIRINFO[0]=DIR_ACTUAL[0];DIRINFO[1]=':';DIRINFO[2]=0; //La \ sera puesta por la otra rutina
 goto FINAL;

 LISTO:;
 sprintf(DIRINFO,TMP);

 FINAL:;
 strncat(DIRINFO,"\\DirInfo",8); //Nombre base
 strncat(DIRINFO,DIR_ACTUAL,1); //Unidad del directorio actual
 strncat(DIRINFO,".Icd",4); //Extension
 }

int main(int ARGC, char *ARGV[])
{
 printf(ENCABEZADO);
 if(ARGC==1) { //Si no se especifica ningun comando
   AYUDA();
   return 0;
   }
 getcwd(DIR_ACTUAL,255);
 TOMAR_NOMBRE_ARCHIVO(); //Pone el nombre y directorio para Dirinfo.icd, archivo que contiene o va a contener los datos de todos los directorios.
 if(ARGV[1][0]=='/' && (ARGV[1][1]=='r' || ARGV[1][1]=='R') ) {
    RASTREAR_DIR();
    return 0;
    }
 BUSCAR_DIR(ARGV[1]); //Busca el directorio
 return 0;
 }

//Comienzo de programacion 3/10/97
